<template>
  <div>
    <div class="container mt-3">
      <div class="panel panel-primary">
        <div class="panel-heading row">
          <h2 class="col-9">Edit Supplier</h2>
        </div>
        <div class="panel-body">
          <form @submit.prevent="editSupplier">
            <div class="form-group mt-2">
              <label>Company Name</label>
              <select
                id="sahuashuash"
                class="form-control"
                v-model="supplier.company_id"
                required
              >
                <option
                  v-for="company in companies"
                  :state-abbr="company.state_abbr"
                  :value="company.id"
                  :key="company.id"
                >
                  {{ company.name }}
                </option>
              </select>
            </div>
            <div class="form-group mt-2">
              <label>Name</label>
              <div v-if="supplierNameError" class="text-danger">
                <p
                  v-for="error in supplierNameError"
                  :key="error"
                  class="small my-0 mb-1"
                >
                  {{ error }}
                </p>
              </div>
              <input
                type="text"
                class="form-control"
                v-model="supplier.name"
                @input="supplierNameError = []"
                required
              />
            </div>
            <div class="my-2">
              <input
                type="radio"
                id="one"
                value="legal"
                v-model="picked"
                @change="selectUserType"
              />
              <label for="one">Legal person</label>
              <br />
              <input
                type="radio"
                id="two"
                value="juridical"
                v-model="picked"
                @change="selectUserType"
              />
              <label for="two">Juridical person</label>
              <br />
            </div>
            <div v-if="juridical == true">
              <div class="form-group mt-2">
                <label>CNPJ</label>
                <div v-if="supplierCNJPError" class="text-danger">
                  <p
                    v-for="error in supplierCNJPError"
                    :key="error"
                    class="small my-0 mb-1"
                  >
                    {{ error }}
                  </p>
                </div>
                <input
                  type="number"
                  class="form-control"
                  v-model="supplier.CNPJ"
                  @input="supplierCNJPError = []"
                />
              </div>
            </div>
            <div v-else>
              <div class="form-group mt-2">
                <label>CPF</label>
                <div v-if="supplierCPFError" class="text-danger">
                  <p
                    v-for="error in supplierCPFError"
                    :key="error"
                    class="small my-0 mb-1"
                  >
                    {{ error }}
                  </p>
                </div>
                <input
                  type="number"
                  class="form-control"
                  v-model="supplier.CPF"
                  @input="supplierCPFError = []"
                />
              </div>
              <div class="form-group mt-2">
                <label>RG</label>
                <input
                  type="number"
                  class="form-control"
                  v-model="supplier.RG"
                  @input="checkSize(supplier.RG)"
                />
              </div>
              <div class="form-outline">
                <label>Birthdate</label>
                <div v-if="supplierBirthdateError" class="text-danger">
                  <p
                    v-for="error in supplierBirthdateError"
                    :key="error"
                    class="small my-0 mb-1"
                  >
                    {{ error }}
                  </p>
                </div>
                <input
                  type="date"
                  class="form-control mt-2"
                  v-model="supplier.birthdate"
                  @input="supplierBirthdateError = []"
                />
              </div>
            </div>
            <div class="form-group mt-2">
              <label>Phones</label>
              <div v-if="supplier.phones.length > 0">
                <table class="table">
                  <thead>
                    <tr>
                      <th scope="col">#</th>
                      <th scope="col">Phone</th>
                    </tr>
                  </thead>
                  <tbody>
                    <tr
                      v-for="(phone, itemObjKey) in supplier.phones"
                      :key="phone"
                      class="small my-0 mb-1"
                    >
                      <th scope="row">{{ itemObjKey + 1 }}</th>
                      <td>{{ phone }}</td>
                    </tr>
                  </tbody>
                </table>
              </div>
              <div class="d-flex">
                <input
                  type="number"
                  class="form-control flex-fill"
                  v-model="newPhone"
                  @input="checkSize(newPhone)"
                  @submit.prevent
                />
                <p
                  type="submit"
                  class="btn btn-primary flex-fill mx-2 my-0"
                  @click="addNewPhone(newPhone)"
                >
                  +
                </p>
              </div>
            </div>
            <button type="submit" class="btn btn-primary mt-3">Edit</button>
          </form>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import cnpjValidation from "../cnpjValidation.js";
import cpfValidation from "../cpfValidation.js";
export default {
  data() {
    return {
      supplier: {
        phones: [],
      },
      newPhone: "",
      companies: {},
      supplierNameError: [],
      supplierCNJPError: [],
      supplierCPFError: [],
      supplierBirthdateError: [],
      juridical: true,
      picked: "juridical",
    };
  },
  created() {
    this.axios.get("http://localhost/api/companies").then((response) => {
      this.companies = response.data.data;
      return this.axios
        .get(`http://localhost/api/suppliers/${this.$route.params.id}`)
        .then((response) => {
          this.supplier = response.data;
          let phones = [];
          response.data.phones.forEach((phone) => {
            phones.push(Number(phone.phone_number));
          });
          this.supplier.phones = phones;
          if (this.supplier.CNPJ) {
            this.picked = "juridical";
          } else {
            this.juridical = false;
            this.picked = "legal";
          }
        });
    });
  },
  methods: {
    editSupplier() {
      if (this.picked == "juridical") {
        if (this.validateJuridicalUser()) {
          this.axios
            .patch(`http://localhost/api/suppliers/${this.$route.params.id}`, {
              company_id: this.supplier.company_id,
              name: this.supplier.name,
              CNPJ: this.supplier.CNPJ,
              phone: this.supplier.phones,
            })
            .then((response) => this.$router.push({ name: "suppliers" }))
            .catch((err) => console.log(err))
            .finally(() => (this.loading = false));
        }
      }
      if (this.picked == "legal") {
        if (this.validateLegalUser()) {
          this.axios
            .patch(`http://localhost/api/suppliers/${this.$route.params.id}`, {
              company_id: this.supplier.company_id,
              name: this.supplier.name,
              CPF: this.supplier.CPF,
              RG: this.supplier.RG,
              birthdate: this.supplier.birthdate,
              phone: this.supplier.phones,
            })
            .then((response) => this.$router.push({ name: "suppliers" }))
            .catch((err) => console.log(err))
            .finally(() => (this.loading = false));
        }
      }
    },
    validateJuridicalUser() {
      if (this.supplier.name.length > 254) {
        if (this.supplierNameError.length == 0) {
          this.supplierNameError.push("- Must be less than 255 characters ");
        }
      }
      if (!this.supplier.CNPJ || !cnpjValidation(this.supplier.CNPJ)) {
        if (this.supplierCNJPError.length == 0) {
          this.supplierCNJPError.push("- This CNPJ is invalid.");
        }
      }
      if (
        this.supplierNameError.length > 0 ||
        this.supplierCNJPError.length > 0
      ) {
        return false;
      }
      return true;
    },
    validateLegalUser() {
      if (!this.supplier.CPF || !cpfValidation(this.supplier.CPF)) {
        if (this.supplierCPFError.length == 0) {
          this.supplierCPFError.push("- This CPF is invalid.");
        }
      }
      if (!this.supplier.birthdate) {
        if (this.supplierBirthdateError.length == 0) {
          this.supplierBirthdateError.push("- This date is required.");
        }
      }
      let date = this.supplier.birthdate + " 00:00:00";
      let old_date = new Date(date).setFullYear(
        new Date(date).getFullYear() + 18
      );
      let company_id = this.supplier.company_id;
      let companyState = document
        .querySelector(`[value="${company_id}"]`)
        .getAttribute("state-abbr");
      if (old_date >= new Date().getTime() && companyState == "PR") {
        if (this.supplierBirthdateError.length <= 1) {
          this.supplierBirthdateError.push(
            "- For companies in the state of Parana, the legal persons must be over 18 years."
          );
        }
      }
      if (
        this.supplierCPFError.length > 0 ||
        this.supplierBirthdateError.length > 0
      ) {
        return false;
      }
      return true;
    },
    selectUserType() {
      if (this.picked == "juridical") {
        this.juridical = true;
        this.supplier.CPF = "";
        this.supplier.RG = "";
        this.supplier.birthdate = "";
        delete this.supplier.CPF;
        delete this.supplier.RG;
        delete this.supplier.birthdate;
      } else {
        this.juridical = false;
        this.supplier.CNPJ = "";
        delete this.supplier.CNP;
      }
    },
    checkSize(item) {
      if (item.length >= 14) {
        this.supplier.RG = item.slice(0, -1);
      }
    },
    addNewPhone(phone) {
      let numberPattern = /\d+/g;
      if (phone.match(numberPattern)) {
        this.supplier.phones.push(Number(phone));
        this.newPhone = "";
      }
    },
  },
};
</script>
